module MapReduce (mapReduce, seqMapReduce)

where

import Control.Parallel
import Control.Parallel.Strategies 


mapReduce :: NFData b => (a -> b) -> ([b] -> c) -> [a] -> c
mapReduce mapper reducer input = pseq mOutput rOutput
  where mOutput = parMap (rpar `dot` rdeepseq) mapper input
        rOutput = reducer mOutput `using` rseq

seqMapReduce :: (a -> b) -> ([b] -> c) -> [a] -> c
seqMapReduce mapper reducer input = reduceResult
  where mapResult = map mapper input
        reduceResult = reducer mapResult
